#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAX_VOZILA 100
#define MAX_IME 31

typedef struct _model{
	char ime[MAX_IME];
	float cena;
}model;

typedef struct _marka{
	char ime[MAX_IME];
	model modeli[MAX_VOZILA];
	int n_modeli;
}marka;

void greska(char *s){
	printf("greska: %s\n", s);
	exit(EXIT_FAILURE);
}

float prosek(model a[], int n_a){
	float prosek = 0;
	int i;
	for(i = 0; i < n_a; i++)
		prosek += a[i].cena;
	
	prosek = prosek / n_a;
	return prosek;
}

int main(){
	marka vozila[100];
	int n_vozila = 0;
	
	char ime_datoteke[MAX_IME];
	printf("unesite ime datoteke: ");
	scanf("%s", ime_datoteke);
	FILE *ulaz = fopen(ime_datoteke, "r");
	if(ulaz == NULL)
		greska("fopen ulaz");
	
	//citamo vozila iz datoteke
	//u zadatku je receno da cemo da procitamo broj vozila na
	//pocetku datoteke, ali mi to necemo, nego cemo malo "otezati"
	//citamo podatke o vozilima sve dok oni postoje u datoteci
	//kako treba po definiciji zadatka uraditi za vezbu...
	
	char temp_marka[MAX_IME];
	char temp_model[MAX_IME];
	float temp_cena;
	
	int i;
	int j;
	
	
	while(fscanf(ulaz, "%s%s%f", temp_marka, 
		temp_model, &temp_cena) == 3)
	{
		//ovde znamo da smo uspeli uspesno da ucitamo
		//3 promenljive:
		//temp_marka temp_model temp_cena
		
		//uvodimo indeks i, neka na pocetku ima vrednost -1
		//trazimo u nizu vozila, marku koja ima ime temp_marka
		//ako nadjemo i stavljamo na taj indeks gde smo pronasli
		//ako ne nadjemo i ostaje -1
		
		i = -1;
		for(j = 0; j < n_vozila; j++){
			if(strcmp(vozila[j].ime, temp_marka) == 0){
				i = j;
				break;
			}
		}
		if(i == -1){
			//nismo nasli vozilo koje ima naziv temp_marka
			//znaci da treba da dodamo novo vozilo u strukturu
			strcpy(vozila[n_vozila].ime, temp_marka);
			vozila[n_vozila].n_modeli = 0;
			n_vozila++;
			//namestamo da nam i bude odgovarajuci indeks,
			//isto kao da smo u gornjoj petlji pronasli vozilo
			i = n_vozila - 1;
		}
		
		//kada smo sigurni za marku dodajemo model:
		int n_modela = vozila[i].n_modeli;
		strcpy(vozila[i].modeli[n_modela].ime, temp_model);
		vozila[i].modeli[n_modela].cena = temp_cena;
		vozila[i].n_modeli++;
	}
	
	fclose(ulaz);
	
	for(i = 0; i < n_vozila; i++){
		printf("marka: %s\n", vozila[i].ime);
		for(j = 0; j < vozila[i].n_modeli; j++)
			printf("model: %s %f\n", 
				vozila[i].modeli[j].ime, 
				vozila[i].modeli[j].cena);
	}
	
	printf("\n\n\n");
	
	for(i = 0; i < n_vozila; i++){
		printf("prosek marke %s je %f\n",
			vozila[i].ime,
			prosek(vozila[i].modeli, vozila[i].n_modeli));
	}
	return 0;
}